namespace Spectre.Console.Composition
{
    /// <summary>
    /// Represents the different border parts.
    /// </summary>
    public enum BorderPart
    {
        /// <summary>
        /// The top left part of a header.
        /// </summary>
        HeaderTopLeft,

        /// <summary>
        /// The top part of a header.
        /// </summary>
        HeaderTop,

        /// <summary>
        /// The top separator part of a header.
        /// </summary>
        HeaderTopSeparator,

        /// <summary>
        /// The top right part of a header.
        /// </summary>
        HeaderTopRight,

        /// <summary>
        /// The left part of a header.
        /// </summary>
        HeaderLeft,

        /// <summary>
        /// A header separator.
        /// </summary>
        HeaderSeparator,

        /// <summary>
        /// The right part of a header.
        /// </summary>
        HeaderRight,

        /// <summary>
        /// The bottom left part of a header.
        /// </summary>
        HeaderBottomLeft,

        /// <summary>
        /// The bottom part of a header.
        /// </summary>
        HeaderBottom,

        /// <summary>
        /// The bottom separator part of a header.
        /// </summary>
        HeaderBottomSeparator,

        /// <summary>
        /// The bottom right part of a header.
        /// </summary>
        HeaderBottomRight,

        /// <summary>
        /// The left part of a cell.
        /// </summary>
        CellLeft,

        /// <summary>
        /// A cell separator.
        /// </summary>
        CellSeparator,

        /// <summary>
        /// The right part of a cell.
        /// </summary>
        ColumnRight,

        /// <summary>
        /// The bottom left part of a footer.
        /// </summary>
        FooterBottomLeft,

        /// <summary>
        /// The bottom part of a footer.
        /// </summary>
        FooterBottom,

        /// <summary>
        /// The bottom separator part of a footer.
        /// </summary>
        FooterBottomSeparator,

        /// <summary>
        /// The bottom right part of a footer.
        /// </summary>
        FooterBottomRight,
    }
}
